package fr.ensicaen.ecole.easygame.gui;

import javax.swing.DefaultListSelectionModel;
import javax.swing.JList;

public final class ZeroOrOneSelectionListModel extends DefaultListSelectionModel {

	private static final long serialVersionUID = 1L;

	private JList<?> _list;

	public ZeroOrOneSelectionListModel(JList<?> list) {
		_list = list;
	}

	public void setSelectionInterval(int i1, int i2) {
		if (i2 - i1 >= 1) {
			i2 = i1;
		}

		super.setSelectionInterval(i1, i2);
	}

	public void addSelectionInterval(int i1, int i2) {
		int selectionLength = _list.getSelectedIndices().length;

		if (selectionLength >= 1) {
			return;
		}

		super.addSelectionInterval(i1, i2);
	}
}
