package fr.ensicaen.ecole.easygame.messaging;

import fr.ensicaen.ecole.easygame.state.Entity;
import fr.ensicaen.ecole.easygame.state.Zone;

/**
 * Signals an entity has been added to a zone.
 */
public final class AddEntityToZoneMessage implements Message {

	private Entity _entity;
	private Zone _zone;

	public AddEntityToZoneMessage(Zone z, Entity e) {
		this._zone = z;
		this._entity = e;
	}

	/**
	 * Returns the entity that has been added to the zone.
	 *
	 * @return Said entity.
	 */
	public Entity getEntity() {
		return _entity;
	}

	/**
	 * Returns the zone in which the entity has been added.
	 *
	 * @return Said zone.
	 */
	public Zone getZone() {
		return _zone;
	}
}
