package fr.ensicaen.ecole.easygame.state;

import java.util.List;

/**
 * Implements an ascending-order player turns management.
 */
public final class AscendingPlayerOrder implements PlayerOrder {

	private static final long serialVersionUID = 1L;

	@Override
	public Player getNextPlayer(GameState gs, Player current) {
		List<Player> players = gs.getPlayers();
		int index = (players.indexOf(current) + 1) % players.size();

		return players.get(index);
	}
}
