package fr.ensicaen.ecole.easygame.state;

import java.io.Serializable;

/**
 * Implements functions responsible for handling the order in which players have to player.
 */
public interface PlayerOrder extends Serializable {

	/**
	 * Computes the player that has to play next.
	 *
	 * @param gs Current game state.
	 * @param current Player that just played.
	 * @return The player that has to play next.
	 */
	Player getNextPlayer(GameState gs, Player current);
}
