package fr.ensicaen.ecole.easygame.state;

import java.awt.Graphics;
import java.io.Serializable;

/**
 * Implements a shape. Used for instance to have different zone shapes.
 */
public interface Shape extends Serializable {

	/**
	 * Tests of the shape contains a specific coordinate.
	 *
	 * @param x x-coordinate to be tested.
	 * @param y y-coordinate to be tested.
	 * @return Whether the (x, y) point is contained by the shape or not.
	 */
	boolean contains(int x, int y);

	/**
	 * Functions used to draw the shape.
	 *
	 * @param g Graphics context used for rendering.
	 */
	void draw(Graphics g);
}
