package fr.ensicaen.ecole.easygame.utils;

import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;

import fr.ensicaen.ecole.easygame.SmarterObjectInputStream;

public final class ObjectUtils {

	private ObjectUtils() {
	}

	public static Serializable deepCopy(Serializable src, ClassLoader loader) {
		Serializable dst = null;

		try {
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			ObjectOutputStream output = new ObjectOutputStream(baos);

			output.writeObject(src);

			ByteArrayInputStream bais = new ByteArrayInputStream(baos.toByteArray());
			ObjectInputStream input;

			if (loader != null) {
				input = new SmarterObjectInputStream(bais, loader);
			} else {
				input = new ObjectInputStream(bais);
			}

			dst = (Serializable) input.readObject();
		} catch (Exception e) {
			e.printStackTrace();
		}

		return dst;
	}
}
