package fr.ensicaen.ecole.guerredesmoutons;

import java.awt.Dimension;
import java.awt.Image;
import java.util.List;

import fr.ensicaen.ecole.easygame.AILogic;
import fr.ensicaen.ecole.easygame.Game;
import fr.ensicaen.ecole.easygame.LaunchableGame;
import fr.ensicaen.ecole.easygame.MiniManager;
import fr.ensicaen.ecole.easygame.messaging.MessageReceiver;
import fr.ensicaen.ecole.easygame.state.GameState;
import fr.ensicaen.ecole.easygame.utils.ImageUtils;

public final class GuerreMoutons extends LaunchableGame {

	public static void main(String[] args) {
		MiniManager.run("fr.ensicaen.ecole.guerredesmoutons.GuerreMoutons", 2);
	}

	@Override
	public MessageReceiver instantiateLogic() {
		return new GuerreMoutonsLogic();
	}

	@Override
	public GameState instantiateGameState() {
		return new GuerreMoutonsGameState();
	}

	@Override
	protected void collectAIClasses(List<Class<? extends AILogic>> l) {
		l.add(GuerreMoutonsAILogic.class);
	}

	@Override
	public void registerPlugins(Game game) {
		game.addPlugin(new ColorPlugin(game));
		game.addPlugin(new ResignPlugin(game));
		game.addPlugin(new PassPlugin(game));
		game.addPlugin(new RotatePlugin(game));
		game.addPlugin(new FlipPlugin(game));
	}

	@Override
	public Dimension getInventoryEntitySize() {
		return new Dimension(GuerreMoutonsCard.INVENTORY_SIZE, GuerreMoutonsCard.INVENTORY_SIZE);
	}

	@Override
	public boolean isCancelTurnAllowed() {
		return true;
	}

	@Override
	public Image getImage() {
		return ImageUtils.openImage(GuerreMoutons.class, "/fr/ensicaen/ecole/guerredesmoutons/mouton.jpg");
	}
}
