package fr.ensicaen.ecole.guerredesmoutons;

import java.util.ArrayList;
import java.util.List;

import fr.ensicaen.ecole.easygame.AILogic;
import fr.ensicaen.ecole.easygame.Game;
import fr.ensicaen.ecole.easygame.state.Inventory;
import fr.ensicaen.ecole.easygame.state.Player;
import fr.ensicaen.ecole.easygame.state.SingleEntityZone;
import fr.ensicaen.ecole.easygame.state.Zone;

public class GuerreMoutonsAILogic implements AILogic {

	private List<Zone> getFreeZones(GuerreMoutonsGameState gs) {
		List<Zone> arrayListFreeZones = new ArrayList<>();

		for (Zone z : gs.getBoard().getZones()) {
			if (z.isEmpty()) {
				arrayListFreeZones.add(z);
			} else if (((GuerreMoutonsCard) z.getEntity(0)).isWolf()) {
				arrayListFreeZones.add(z);
			}
		}

		return arrayListFreeZones;
	}

	@Override
	public void think(Game game, Player p) {
		GuerreMoutonsGameState gs = (GuerreMoutonsGameState) game.getGameState();
		GuerreMoutonsPlayer gmp = (GuerreMoutonsPlayer) p;
		Inventory inv = p.getInventory();

		boolean hasPlayed = false;
		for (int i = 0; i < inv.getEntityCount(); ++i) {
			GuerreMoutonsCard card = (GuerreMoutonsCard) inv.getEntity(i);

			for (Zone z : getFreeZones(gs)) {
				// Si on peut jouer la carte, on la joue, sinon on réessaye de
				// la jouer apres l'avoir retournée

				for (int j = 0; j < 4; ++j) {
					if (GuerreMoutonsLogic.canPlay(game, card, (SingleEntityZone) z)) {
						hasPlayed = true;
						GuerreMoutonsLogic.play(game, card, (SingleEntityZone) z);
						break;
					} else {
						card.rotateRight();
					}
				}

				if (hasPlayed) {
					break;
				}

				card.flip();

				for (int j = 0; j < 4; ++j) {
					if (GuerreMoutonsLogic.canPlay(game, card, (SingleEntityZone) z)) {
						hasPlayed = true;
						GuerreMoutonsLogic.play(game, card, (SingleEntityZone) z);
						break;
					} else {
						card.rotateRight();
					}
				}

				if (hasPlayed) {
					break;
				}
			}
		}
		if (!hasPlayed) {
			int nbGiveUp = 0;

			for (Player player : gs.getPlayers()) {
				if (((GuerreMoutonsPlayer) player).hasLeft()) {
					nbGiveUp++;
				}
			}

			if (gs.getPlayers().size() - 1 == nbGiveUp) {
				gmp.leaveGame();
				gs.onGiveUpPlayer(gmp);
			}
		}

		if (inv.getEntityCount() == 0) {
			gmp.leaveGame();
			gs.onGiveUpPlayer(gmp);
		}

		game.endTurn();
		game.submitTurn();
	}
}
