package fr.ensicaen.ecole.guerredesmoutons;

import java.util.ArrayList;
import java.util.List;

import fr.ensicaen.ecole.easygame.state.GameState;
import fr.ensicaen.ecole.easygame.state.Player;
import fr.ensicaen.ecole.easygame.state.SingleEntityZone;

public final class GuerreMoutonsGameState extends GameState {

	private static final long serialVersionUID = 1L;

	private List<GuerreMoutonsCard> _deck = new ArrayList<>();
	private List<GuerreMoutonsPlayer> _orderGiveUp = new ArrayList<>();
	private int[] _scoreGiveUp = {6, 3, 1, 0};
	private SingleEntityZone _lastPlayedZone;

	GuerreMoutonsGameState() {
		super(new GuerreMoutonsBoard(), new GuerreMoutonsPlayerOrder());
	}

	void addCardToDeck(GuerreMoutonsCard card) {
		_deck.add(card);
	}

	GuerreMoutonsCard drawCardFromDeck() {
		if (_deck.size() == 0) {
			return null;
		}

		int id = (int) (Math.random() * _deck.size());
		GuerreMoutonsCard c = _deck.get(id);
		_deck.remove(id);

		return c;
	}

	void onGiveUpPlayer(GuerreMoutonsPlayer p) {
		_orderGiveUp.add(p);
	}

	int getPoints(Player player) {
		for (int i = 0; i < _orderGiveUp.size(); ++i) {
			if (player.equals(_orderGiveUp.get(i))) {
				return _scoreGiveUp[i];
			}
		}

		return 0;
	}

	SingleEntityZone getLastPlayedZone() {
		return _lastPlayedZone;
	}

	void setLastPlayedZone(SingleEntityZone lastPlayedZone) {
		_lastPlayedZone = lastPlayedZone;
	}
}
