package fr.ensicaen.ecole.guerredesmoutons;

import java.awt.Color;

import fr.ensicaen.ecole.easygame.state.Player;

public final class GuerreMoutonsPlayer extends Player {

	private static final long serialVersionUID = 1L;

	private Color _color;
	private boolean _hasLeft = false;

	GuerreMoutonsPlayer(int id, String nickname, Color color) {
		super(id, nickname);
		this._color = color;
	}

	Color getColor() {
		return _color;
	}

	boolean hasLeft() {
		return _hasLeft;
	}

	void leaveGame() {
		_hasLeft = true;
	}

	String getNameColor() {
		if (_color.equals(Color.BLUE)) {
			return "bleu";
		} else if (_color.equals(Color.RED)) {
			return "rouge";
		} else if (_color.equals(Color.BLACK)) {
			return "noir";
		} else {
			return "jaune";
		}
	}
}
