package fr.ensicaen.ecole.guerredesmoutons;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;

import fr.ensicaen.ecole.easygame.Game;
import fr.ensicaen.ecole.easygame.plugin.Plugin;
import fr.ensicaen.ecole.easygame.state.Inventory;

class RotatePlugin extends Plugin {

	RotatePlugin(Game game) {
		super(game);
	}

	@Override
	public JPanel buildUI() {
		JPanel panel = new JPanel();
		panel.setLayout(new BorderLayout());
		panel.add(new JLabel("Tourner la carte : "), BorderLayout.PAGE_START);

		JPanel buttonPanel = new JPanel();
		buttonPanel.setLayout(new BoxLayout(buttonPanel, BoxLayout.LINE_AXIS));
		panel.add(buttonPanel, BorderLayout.PAGE_END);

		JButton button = new JButton("<-");
		button.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				Inventory inv = getGame().getGameState().getCurrentPlayer().getInventory();
				if (inv.isCurrentlyDisplayed()) {
					GuerreMoutonsCard c = (GuerreMoutonsCard) inv.getSelectedEntity();
					if (c != null) {
						c.rotateLeft();
						inv.updateView();
					}
				}
			}
		});

		buttonPanel.add(button);

		button = new JButton("->");
		button.addActionListener(new ActionListener() {
			@Override
			public void actionPerformed(ActionEvent e) {
				Inventory inv = getGame().getGameState().getCurrentPlayer().getInventory();
				if (inv.isCurrentlyDisplayed()) {
					GuerreMoutonsCard c = (GuerreMoutonsCard) inv.getSelectedEntity();
					if (c != null) {
						c.rotateRight();
						inv.updateView();
					}
				}
			}
		});

		buttonPanel.add(button);

		// Used for centering, dunno why
		JPanel outsidePanel = new JPanel();
		outsidePanel.add(panel);

		return outsidePanel;
	}
}
