package fr.ensicaen.ecole.manager;

import java.io.IOException;
import java.net.URL;

import javax.swing.JEditorPane;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import javax.swing.text.Document;

class ActivatedHyperlinkListener implements HyperlinkListener {

	private JEditorPane _editorPane;

	public ActivatedHyperlinkListener(JEditorPane editorPane) {
		_editorPane = editorPane;
	}

	public void hyperlinkUpdate(HyperlinkEvent hyperlinkEvent) {
		HyperlinkEvent.EventType type = hyperlinkEvent.getEventType();
		final URL url = hyperlinkEvent.getURL();

		if (type == HyperlinkEvent.EventType.ENTERED) {
			System.out.println("URL: " + url);
		} else if (type == HyperlinkEvent.EventType.ACTIVATED) {
			Document doc = _editorPane.getDocument();

			try {
				_editorPane.setPage(url);
			} catch (IOException ioException) {
				System.out.println("Error following link");
				_editorPane.setDocument(doc);
			}
		}
	}
}