package fr.ensicaen.ecole.manager;

import java.awt.Dimension;
import java.awt.Image;
import java.io.IOException;

import javax.imageio.ImageIO;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.border.Border;

import fr.ensicaen.ecole.easygame.utils.ImageUtils;

public class GameButton extends JButton {

	private static final long serialVersionUID = 1L;

	private static final int WIDTH = 100;
	private static final int HEIGHT = 100;
	private InfoGame _info;

	public GameButton(InfoGame info) {
		_info = info;
		Image image = info.getImage();

		if (image == null) {
			Image img2 = null;

			try {
				img2 = ImageIO.read(getClass().getResourceAsStream("data/no_image.png"));
			} catch (IOException e) {
				e.printStackTrace();
			}

			image = ImageUtils.resizeImage(img2, WIDTH, HEIGHT);
		} else {
			image = ImageUtils.resizeImage(image, WIDTH, HEIGHT);
		}

		setMinimumSize(new Dimension(WIDTH, HEIGHT));
		setIcon(new ImageIcon(image));

		Border emptyBorder = BorderFactory.createEmptyBorder(10, 10, 10, 10);

		setBorder(emptyBorder);
		setToolTipText(_info.getName());
		setBackground(GameManager.GRAY);
	}

	public final InfoGame getInfo() {
		return _info;
	}
}
