package fr.ensicaen.ecole.manager;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.GridLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerNumberModel;
import javax.swing.SwingConstants;

public final class JoinPanel extends PlayPanel implements ActionListener {

	private static final long serialVersionUID = 1L;

	private InfoGame _infoGame;
	private JTextField _ip = new JTextField(12);
	private JTextField _nickname = new JTextField(12);
	private JSpinner _port = new JSpinner(new SpinnerNumberModel(4545, 1025, 65534, 1));
	private JButton _play = new JButton("Jouer");

	public JoinPanel(GameManager manager, InfoGame game) {
		super(manager);
		_infoGame = game;

		_play.addActionListener(this);
		GridLayout gr = new GridLayout(3, 1, 12, 1);
		JPanel panel = new JPanel();
		panel.setLayout(gr);

		super.getMainPanel().setBorder(BorderFactory.createLineBorder(Color.black));
		_ip.setPreferredSize(new Dimension(200, 30));
		_port.setPreferredSize(new Dimension(185, 30));
		_nickname.setPreferredSize(new Dimension(170, 30));
		JLabel labelIp = new JLabel("IP :");
		panel.add(labelIp, BorderLayout.WEST);
		panel.add(_ip, BorderLayout.CENTER);
		JLabel labelPort = new JLabel("Port :");
		panel.add(labelPort, BorderLayout.WEST);
		panel.add(_port, BorderLayout.CENTER);
		JLabel labelNickname = new JLabel("Pseudo :");
		panel.add(labelNickname, BorderLayout.WEST);
		panel.add(_nickname, BorderLayout.CENTER);
		panel.setBorder(BorderFactory.createLoweredBevelBorder());
		labelIp.setHorizontalAlignment(SwingConstants.RIGHT);
		labelPort.setHorizontalAlignment(SwingConstants.RIGHT);
		labelNickname.setHorizontalAlignment(SwingConstants.RIGHT);

		super.getSouthPanel().add(_play);
		super.getMainPanel().add(panel);

		setTitle("Rejoindre partie de " + _infoGame.getName());
		pack();
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		super.actionPerformed(e);

		if (e.getSource().equals(_play)) {
			if (_nickname.getText().isEmpty()) {
				_nickname.grabFocus();
				return;
			}

			int port = (int) _port.getValue();

			if (super.getManager().launchGameAsClient(_infoGame, _ip.getText(), port, _nickname.getText())) {
				this.setVisible(false);
			} else {
				JOptionPane.showMessageDialog(null,
						"Aucun serveur de jeu trouvé à la destination renseignée.",
						"Alert", JOptionPane.ERROR_MESSAGE);
			}
		}
	}
}
