package fr.ensicaen.ecole.manager;

import java.awt.BorderLayout;

import javax.swing.BorderFactory;
import javax.swing.JDialog;
import javax.swing.JProgressBar;
import javax.swing.SwingUtilities;
import javax.swing.border.Border;

public final class LoadingDialog extends JDialog implements Runnable {

	private static final long serialVersionUID = 1L;

	private JProgressBar _progressBar;
	private UpdateDialog _up;

	public LoadingDialog(UpdateDialog up) {
		_up = up;
		setTitle("Chargement");
		_progressBar = new JProgressBar();
		_progressBar.setValue(0);
		_progressBar.setStringPainted(true);
		Border border = BorderFactory.createTitledBorder("Téléchargement");
		_progressBar.setBorder(border);
		add(_progressBar, BorderLayout.NORTH);
		setResizable(false);
		setSize(300, 100);
		runUpdate();
	}

	private void updateBar(int n) {
		_progressBar.setValue(n);
	}

	private void runUpdate() {
		Thread t = new Thread(this);
		t.start();
	}

	@Override
	public void run() {
		this.update();
	}

	private void update() {
		_up.getUpdate();
	}

	public void majProgress() {
		if (SwingUtilities.isEventDispatchThread()) {
			if (_up.getProgress() >= 100) {
				this.setModal(false);
				this.setAlwaysOnTop(false);
				this.setVisible(false);
				_up.setVisible(false);
			}
			updateBar(_up.getProgress());
		} else {
			Runnable callMAJ = new Runnable() {
				public void run() {
					majProgress();
				}
			};
			SwingUtilities.invokeLater(callMAJ);
		}
	}
}
