package fr.ensicaen.ecole.manager;

import java.awt.Desktop;
import java.io.IOException;
import java.net.URI;
import java.net.URISyntaxException;

import javax.swing.JEditorPane;
import javax.swing.JFrame;
import javax.swing.JScrollPane;
import javax.swing.event.HyperlinkListener;

public class MiniBrowser extends JFrame {

	private static final long serialVersionUID = 1L;

	private InfoGame _current;
	private JEditorPane _jep;

	public MiniBrowser(InfoGame current) {
		_current = current;
		goToWebSite();
	}

	private void buildInterface() {
		_jep = new JEditorPane();
		_jep.setEditable(false);

		JScrollPane scrollPane = new JScrollPane(_jep);
		HyperlinkListener hyperlinkListener = new ActivatedHyperlinkListener(_jep);
		_jep.addHyperlinkListener(hyperlinkListener);

		add(scrollPane);

		setSize(512, 342);
		this.setVisible(true);
	}

	public final void goToWebSite() {
		String url = _current.getUrl();

		if (Desktop.isDesktopSupported()) {
			Desktop desktop = Desktop.getDesktop();
			try {
				desktop.browse(new URI(url));
			} catch (IOException | URISyntaxException e) {
				try {
					buildInterface();
					_jep.setPage(url);
				} catch (IOException e1) {
					_jep.setContentType("text/html");
					_jep.setText("<html>L'adresse n'est pas valide</html>");
				}
			}
		} else {
			Runtime runtime = Runtime.getRuntime();
			try {
				runtime.exec("xdg-open " + url);
			} catch (IOException e) {
				try {
					buildInterface();
					_jep.setPage(url);
				} catch (IOException e1) {
					_jep.setContentType("text/html");
					_jep.setText("<html>L'adresse n'est pas valide</html>");
				}
			}
		}
	}
}
