package fr.ensicaen.ecole.manager;

import java.awt.BorderLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JPanel;

public abstract class PlayPanel extends JDialog implements ActionListener {

	private static final long serialVersionUID = 1L;

	private GameManager _manager;
	private JPanel _mainPanel = new JPanel(new BorderLayout());
	private JButton _cancel = new JButton("Annuler");
	private JPanel _south = new JPanel();

	public PlayPanel(GameManager manager) {
		this._manager = manager;
		_cancel.addActionListener(this);

		_south.add(_cancel);
		_mainPanel.add(_south, BorderLayout.SOUTH);
		setResizable(false);

		add(_mainPanel);
		setModal(true);
	}

	protected final JPanel getMainPanel() {
		return _mainPanel;
	}

	protected final JPanel getSouthPanel() {
		return _south;
	}

	protected final GameManager getManager() {
		return _manager;
	}

	@Override
	public void actionPerformed(ActionEvent e) {
		if (e.getSource().equals(_cancel)) {
			this.setVisible(false);
		}
	}
}
