package fr.ensicaen.ecole.reversi;

import java.awt.Dimension;
import java.awt.Image;
import java.util.List;

import fr.ensicaen.ecole.easygame.AILogic;
import fr.ensicaen.ecole.easygame.Game;
import fr.ensicaen.ecole.easygame.LaunchableGame;
import fr.ensicaen.ecole.easygame.MiniManager;
import fr.ensicaen.ecole.easygame.messaging.MessageReceiver;
import fr.ensicaen.ecole.easygame.state.GameState;
import fr.ensicaen.ecole.easygame.utils.ImageUtils;

public final class Reversi extends LaunchableGame {

	public static void main(String[] args) {
		MiniManager.run("fr.ensicaen.ecole.reversi.Reversi", 2);
	}

	@Override
	public MessageReceiver instantiateLogic() {
		return new ReversiLogic();
	}

	@Override
	public GameState instantiateGameState() {
		return new ReversiGameState();
	}

	@Override
	protected void collectAIClasses(List<Class<? extends AILogic>> l) {
	}

	@Override
	public void registerPlugins(Game game) {
	}

	@Override
	public Dimension getInventoryEntitySize() {
		return new Dimension(1, 1);
	}

	@Override
	public boolean isCancelTurnAllowed() {
		return true;
	}

	@Override
	public Image getImage() {
		return ImageUtils.openImage(Reversi.class, "/fr/ensicaen/ecole/reversi/reversi.png");
	}
}
