package fr.ensicaen.ecole.reversi;

import java.awt.Color;
import java.awt.Graphics;
import java.awt.Image;

import fr.ensicaen.ecole.easygame.state.Entity;
import fr.ensicaen.ecole.easygame.state.Player;
import fr.ensicaen.ecole.easygame.utils.ImageUtils;

class ReversiPiece extends Entity {

	private static final long serialVersionUID = 1L;

	public static class Images {

		private static final Image WHITE = open("pion_blanc");
		private static final Image BLACK = open("pion_noir");

		private static Image open(String file) {
			return ImageUtils.openImage(Reversi.class, "/fr/ensicaen/ecole/reversi/images/" + file + ".png");
		}
	}

	public ReversiPiece(Player p) {
		super.setPlayer(p);
	}

	@Override
	public void draw(Graphics g) {
		Color color = ((ReversiPlayer) getPlayer()).getColor();
		int w = ReversiBoard.W;

		if (color.equals(Color.WHITE)) {
			g.drawImage(Images.WHITE, 0, 0, w, w, null);
		} else {
			g.drawImage(Images.BLACK, 0, 0, w, w, null);
		}
	}
}
