package fr.ensicaen.ecole.uno;

import java.awt.Dimension;
import java.awt.Image;
import java.util.List;

import fr.ensicaen.ecole.easygame.AILogic;
import fr.ensicaen.ecole.easygame.Game;
import fr.ensicaen.ecole.easygame.LaunchableGame;
import fr.ensicaen.ecole.easygame.MiniManager;
import fr.ensicaen.ecole.easygame.messaging.MessageReceiver;
import fr.ensicaen.ecole.easygame.state.GameState;
import fr.ensicaen.ecole.easygame.utils.ImageUtils;

public final class Uno extends LaunchableGame {

	public static void main(String[] args) {
		MiniManager.run("fr.ensicaen.ecole.uno.Uno", 2);
	}

	@Override
	public MessageReceiver instantiateLogic() {
		return new UnoLogic();
	}

	@Override
	public GameState instantiateGameState() {
		return new UnoGameState();
	}

	protected void collectAIClasses(List<Class<? extends AILogic>> l) {
		l.add(UnoAILogic.class);
	}

	@Override
	public void registerPlugins(Game game) {
		game.addPlugin(new PassPlugin(game));
		game.addPlugin(new SwitchPlugin(game));
	}

	@Override
	public Dimension getInventoryEntitySize() {
		return new Dimension(UnoCard.INV_W, UnoCard.INV_H);
	}

	@Override
	public boolean isCancelTurnAllowed() {
		return false;
	}

	@Override
	public Image getImage() {
		return ImageUtils.openImage(Uno.class, "/fr/ensicaen/ecole/uno/uno.jpg");
	}
}
