package fr.ensicaen.ecole.uno;

import java.awt.Color;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Random;

import fr.ensicaen.ecole.easygame.AILogic;
import fr.ensicaen.ecole.easygame.Game;
import fr.ensicaen.ecole.easygame.state.Inventory;
import fr.ensicaen.ecole.easygame.state.Player;

public final class UnoAILogic implements AILogic {

	private Random _rand = new Random();

	@Override
	public void think(Game game, Player p) {
		try {
			Thread.sleep(800);
		} catch (InterruptedException ignored) {
		}

		UnoGameState gs = (UnoGameState) game.getGameState();
		Inventory inv = p.getInventory();
		List<UnoCard> possibles = new ArrayList<>();

		HashMap<Color, Integer> hm = new HashMap<>();
		Color[] typeColor = {Color.BLUE, Color.RED, Color.GREEN, Color.YELLOW};
		for (Color c : typeColor) {
			hm.put(c, 0);
		}

		for (int i = 0; i < inv.getEntityCount(); ++i) {
			UnoCard card = (UnoCard) inv.getEntity(i);

			if (gs.canPlay(p, card)) {
				possibles.add(card);
			}

			hm.put(card.getColor(), hm.get(card.getColor()) + 1);
		}

		if (possibles.isEmpty()) {
			gs.getCurrentPlayer().getInventory().addEntity(gs.drawCardFromDeck());
		} else {
			UnoCard c = possibles.get(_rand.nextInt(possibles.size()));

			if (c.getType().equals(CardType.DRAW4) || c.getType().equals(CardType.COLOR)) {
				Color best = Color.BLUE;
				for (Color color : typeColor) {
					if (hm.get(color) > hm.get(best)) {
						best = color;
					}
				}

				while (!c.getColor().equals(best)) {
					c.nextColor();
				}
			}

			gs.play(p, c);
		}
		game.endTurn();
	}
}
