package fr.ensicaen.ecole.uno;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Image;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Comparator;
import java.util.List;

import fr.ensicaen.ecole.easygame.state.Board;
import fr.ensicaen.ecole.easygame.state.Player;
import fr.ensicaen.ecole.easygame.state.RectangleShape;
import fr.ensicaen.ecole.easygame.state.Zone;
import fr.ensicaen.ecole.easygame.utils.ImageUtils;

final class UnoBoard extends Board {

	private static final long serialVersionUID = 1L;

	private static Image _boardImg = ImageUtils.openImage(Uno.class, "/fr/ensicaen/ecole/uno/images/board.png");
	private static Image _boardMask = ImageUtils.openImage(Uno.class, "/fr/ensicaen/ecole/uno/images/board_mask.png");

	private Zone _playZone = new Zone(0, 0, new RectangleShape(UnoCard.BOARD_W, UnoCard.BOARD_H, false));
	private UnoGameState _gs = null;

	UnoBoard() {
		addZone(_playZone);
	}

	void setGameState(UnoGameState gs) {
		_gs = gs;
	}

	@Override
	public Dimension getDimension() {
		return new Dimension(UnoCard.BOARD_W, UnoCard.BOARD_H);
	}

	Zone getPlayZone() {
		return _playZone;
	}

	@Override
	public void draw(Graphics g) {
		g.drawImage(_boardImg, -188, -79, null);
		super.draw(g);
		g.drawImage(_boardMask, 0, 0, null);

		int i = 0;
		
		for (Player p : _gs.getPlayers()) {
			UnoPlayer up = (UnoPlayer) p;

			if (p.getId() == _gs.getCurrentPlayer().getId()) {
				g.setColor(new Color(255, 255, 255));
			} else {
				g.setColor(new Color(175, 215, 145));
			}

			g.drawString(up.getNickname() + " : " + up.getLastRoundPoints() + " (" + up.getPoints() + ")", -160, -45 + i * 24);
			i++;
		}
		
		g.setColor(new Color(175, 215, 145));
		g.drawString("Manche n°" + _gs.getNbRound(), 33, -45);
		
		if (_gs.isNewRound()) {
			g.drawString("Fin de la manche", 20, 225);
		}
	}
}
