package net.kidanger.yourchess;

import java.awt.Dimension;
import java.awt.Image;
import java.util.List;

import fr.ensicaen.ecole.easygame.AILogic;
import fr.ensicaen.ecole.easygame.Game;
import fr.ensicaen.ecole.easygame.LaunchableGame;
import fr.ensicaen.ecole.easygame.MiniManager;
import fr.ensicaen.ecole.easygame.messaging.MessageReceiver;
import fr.ensicaen.ecole.easygame.state.GameState;
import fr.ensicaen.ecole.easygame.utils.ImageUtils;

public final class Chess extends LaunchableGame {

	public static void main(String[] args) {
		MiniManager.run("net.kidanger.yourchess.Chess", 2);
	}

	@Override
	public MessageReceiver instantiateLogic() {
		return new ChessLogic();
	}

	@Override
	public GameState instantiateGameState() {
		return new ChessGameState();
	}

	@Override
	public void registerPlugins(Game game) {
	}

	@Override
	protected void collectAIClasses(List<Class<? extends AILogic>> l) {
		l.add(SmartChessAILogic.class);
	}

	@Override
	public Dimension getInventoryEntitySize() {
		return new Dimension(1, 1);
	}

	@Override
	public boolean isCancelTurnAllowed() {
		return false;
	}

	@Override
	public Image getImage() {
		return ImageUtils.openImage(Chess.class, "/net/kidanger/yourchess/chess.png");
	}
}
