package net.kidanger.yourchess;

import java.awt.Color;
import java.awt.Dimension;
import java.awt.Graphics;

import net.kidanger.yourchess.yourchess.coup.Coup;
import net.kidanger.yourchess.yourchess.coup.IDeplacement;
import net.kidanger.yourchess.yourchess.piece.Piece;
import net.kidanger.yourchess.yourchess.Echiquier;
import net.kidanger.yourchess.yourchess.Partie;
import fr.ensicaen.ecole.easygame.state.Board;
import fr.ensicaen.ecole.easygame.state.Shape;
import fr.ensicaen.ecole.easygame.state.SingleEntityZone;
import fr.ensicaen.ecole.easygame.state.Zone;

final class ChessBoard extends Board {

	static public final int W = 48;
	private Echiquier _echiquier;

	ChessBoard() {
		for (int x = 0; x < 8; x++) {
			for (int y = 0; y < 8; y++) {
				Shape shape = new SelectedZoneShape(W, W);
				addZone(new SingleEntityZone(x * W, y * W, shape));
			}
		}
	}

	public void refresh(Partie partie) {
		for (Zone z : getZones()) {
			z.clear();
			((SelectedZoneShape) z.getShape()).setWasMoved(false);
		}
		for (Piece p : _echiquier.getPieces()) {
			ChessPiece cp = new ChessPiece(p);
			Zone z = getZoneAt(cp.getPlateauX(), cp.getPlateauY());
			z.addEntity(cp);
		}
		Coup c = partie.coupPrecedent();
		if (c instanceof IDeplacement) {
			IDeplacement dep = (IDeplacement) c;
			Zone z = getZoneAt((dep.getSource().getX() - 1) * W, (8 - dep.getSource().getY()) * W);
			((SelectedZoneShape) z.getShape()).setWasMoved(true);
			z = getZoneAt((dep.getDestination().getX() - 1) * W, (8 - dep.getDestination().getY()) * W);
			((SelectedZoneShape) z.getShape()).setWasMoved(true);
		}
	}

	@Override
	public Dimension getDimension() {
		return new Dimension(W * 8, W * 8);
	}

	@Override
	public void draw(Graphics g) {
		g.setColor(Color.lightGray);
		g.fillRect(0, 0, 8 * W, 8 * W);
		super.draw(g);
	}

	public void setEchiquier(Echiquier echiquier) {
		_echiquier = echiquier;
	}
}
