package net.kidanger.yourchess;

import java.awt.Color;
import java.awt.Graphics;

import fr.ensicaen.ecole.easygame.state.RectangleShape;

final class SelectedZoneShape extends RectangleShape {

	private boolean _selected;
	private boolean _wasMoved;

	public SelectedZoneShape(int w, int h) {
		super(w, h, true);
	}

	@Override
	public void draw(Graphics g) {
		super.draw(g);
		if (_wasMoved) {
			g.setColor(new Color(100, 100, 0, 75));
			g.fillRect(0, 0, getW(), getH());
		}
		if (_selected) {
			g.setColor(new Color(0, 150, 0, 100));
			g.fillRect(0, 0, getW(), getH());
		}
	}

	public void setSelected(boolean selected) {
		_selected = selected;
	}

	public void setWasMoved(boolean moved) {
		_wasMoved = moved;
	}
}
