package net.kidanger.yourchess.yourchess.coup;

import java.io.Serializable;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Echiquier;

abstract public class Coup implements Serializable {

	abstract public void jouer(Echiquier e, Couleur c);
	abstract public void dejouer(Echiquier e, Couleur c);

	abstract public String notationComplete();
	abstract public String notationAbregee(Echiquier e);

	abstract public boolean equals(Coup c);
	abstract public boolean lowEquals(IDeplacement c);

	boolean isRoque() {
		return this instanceof Roque;
	}

	public boolean isDeplacement() {
		return this instanceof Deplacement;
	}

	public boolean isPriseEnPassant() {
		return this instanceof PriseEnPassant;
	}

	public String toString() {
		return notationComplete();
	}
}
