package net.kidanger.yourchess.yourchess.coup;

import net.kidanger.yourchess.yourchess.Partie;
import net.kidanger.yourchess.yourchess.Position;
import net.kidanger.yourchess.yourchess.piece.Piece;

public class CoupFactory {

	static public Coup create(Partie partie, final Piece p, final Position pos) {
		IDeplacement depla = new IDeplacement() {
			public Piece getPiece() {
				return p;
			}

			public Position getSource() {
				return p.getPosition();
			}

			public Position getDestination() {
				return pos;
			}
		};

		for (Coup c : partie.listeDesCoupsCouleur(p.getCouleur())) {
			if (c.lowEquals(depla)) {
				return c;
			}
		}
		return null;
	}
}

