package net.kidanger.yourchess.yourchess.ordinateur;

import java.io.Serializable;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Partie;

abstract class Evaluateur implements Serializable {

	private Evaluateur parent = null;

	Evaluateur() {
	}

	Evaluateur(Evaluateur e) {
		this.parent = e;
	}

	abstract public int evalue(Partie partie, Couleur c);

	int parentEvalue(Partie partie, Couleur c) {
		if (parent == null)
			return 0;
		return parent.evalue(partie, c);
	}

	abstract protected String getNom();

	public String toString() {
		if (parent == null)
			return getNom();
		return getNom() + ", " + parent;
	}
}
