package net.kidanger.yourchess.yourchess.ordinateur;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Partie;
import net.kidanger.yourchess.yourchess.coup.Coup;
import net.kidanger.yourchess.yourchess.coup.IPrise;

public class EvaluateurPrise extends Evaluateur {

	public EvaluateurPrise() {
	}

	public EvaluateurPrise(Evaluateur e) {
		super(e);
	}

	public int evalue(Partie partie, Couleur c) {
		int points = 0;

		for (Coup coup : partie.listeDesCoupsCouleur(c)) {
			if (coup instanceof IPrise) {
				IPrise cp = (IPrise) coup;
				if (cp.getPrise() != null)
					points += cp.getPrise().getPoints() * 2;
			}
		}

		for (Coup coup : partie.listeDesCoupsCouleur(c.other())) {
			if (coup instanceof IPrise) {
				IPrise cp = (IPrise) coup;
				if (cp.getPrise() != null)
					points -= cp.getPrise().getPoints() * 2;
			}
		}

		return points + parentEvalue(partie, c);
	}

	protected String getNom() {
		return "Prs";
	}
}
