package net.kidanger.yourchess.yourchess.ordinateur;

import java.util.Collections;
import java.util.List;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Partie;
import net.kidanger.yourchess.yourchess.coup.Coup;

public class OrdinateurMoyen extends Ordinateur {

	private Evaluateur evaluateur;

	public OrdinateurMoyen(Couleur couleur) {
		super("Moyen", couleur);
		this.evaluateur = new EvaluateurFinDePartie(new EvaluateurCoefficient(new EvaluateurPrise()));
	}

	public Coup jouerCoup() {
		Coup coup = chercheCoup(partie, couleur, -10000, 10000);

		System.out.println("[moyen] en " + coup);
		return coup;
	}

	private Coup chercheCoup(Partie partie, Couleur c, int alpha, int beta) {
		List<Coup> coups = partie.listeDesCoupsCouleur(c);

		Coup best = null;
		int val;
		Collections.shuffle(coups);
		for (Coup coup : coups) {

			partie.testJouerCoup(c, coup);

			val = -evaluateur.evalue(partie, c.other());

			if (val >= alpha) {
				alpha = val;
				best = coup;
			}

			partie.testDejouerCoup(c, coup);

			if (val >= beta) {
				break;
			}
		}
		return best;
	}

	public String getNom() {
		return "KISS (" + evaluateur + ")";
	}

	public String toString() {
		return getNom();
	}
}
