package net.kidanger.yourchess.yourchess.piece;

import java.util.LinkedList;
import java.util.List;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Echiquier;
import net.kidanger.yourchess.yourchess.Position;

public class Cavalier extends Piece {

	public Cavalier(Position position, Couleur couleur) {
		super(position, couleur);
	}

	private void add(List<Position> l, Echiquier e, int x, int y) {
		if (x > 8 || x < 1 || y > 8 || y < 1) {
			return;
		}
		if (e == null) {
			l.add(Position.get(x, y));
			return;
		}
		Piece p = e.getPiecePosition(x, y);
		if (p != null) {
			if (!isFriendly(p)) {
				l.add(Position.get(x, y));
			}
		} else {
			l.add(Position.get(x, y));
		}
	}

	public List<Position> getPossiblePositions(Echiquier e, boolean checkOthers) {
		// http://iechecs.com/img1/dep_c.png
		List<Position> liste = new LinkedList<>();
		int tx = position.getX();
		int ty = position.getY();

		for (int dx = -1; dx <= 1; dx += 2) {
			for (int dy = -1; dy <= 1; dy += 2) {
				add(liste, e, tx + 2 * dx, ty + dy);
				add(liste, e, tx + dx, ty + 2 * dy);
			}
		}

		return liste;
	}

	public int getPoints() {
		return 3;
	}

	public char toSmallString() {
		if (couleur.isBlanc())
			return '♞';
		return '♘';
	}
}
