package net.kidanger.yourchess.yourchess.piece;

import java.util.List;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Echiquier;
import net.kidanger.yourchess.yourchess.Position;

public class Dame extends Piece {

	private Tour tour;
	private Fou fou;

	public Dame(Position position, Couleur couleur) {
		super(position, couleur);
		tour = new Tour(position, couleur);
		fou = new Fou(position, couleur);
	}

	public List<Position> getPossiblePositions(Echiquier e, boolean checkOthers) {
		List<Position> liste = tour.getPossiblePositions(e, checkOthers);
		liste.addAll(fou.getPossiblePositions(e, checkOthers));
		return liste;
	}

	public void onMove(Position dst) {
		super.onMove(dst);
		fou.onMove(dst);
		tour.onMove(dst);
	}

	public void onUnmove(Position dst) {
		super.onUnmove(dst);
		fou.onUnmove(dst);
		tour.onUnmove(dst);
	}

	public int getPoints() {
		return 5;
	}

	public char toSmallString() {
		if (couleur.isBlanc())
			return '♛';
		return '♕';
	}
}
