package net.kidanger.yourchess.yourchess.piece;

import java.util.LinkedList;
import java.util.List;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Echiquier;
import net.kidanger.yourchess.yourchess.Position;

public class Fou extends Piece {

	public Fou(Position position, Couleur couleur) {
		super(position, couleur);
	}

	private void add(List<Position> l, Echiquier e, int x, int y) {
		if (e == null) {
			l.add(Position.get(x, y));
			return;
		}
		Piece p = e.getPiecePosition(x, y);
		if (p != null) {
			if (!isFriendly(p)) {
				l.add(Position.get(x, y));
			}
		} else {
			l.add(Position.get(x, y));
		}
	}

	public List<Position> getPossiblePositions(Echiquier e, boolean checkOthers) {
		List<Position> liste = new LinkedList<>();
		int tx = position.getX();
		int ty = position.getY();

		double angle = Math.PI / 4;
		while (angle <= Math.PI * 2) {
			int dx = (int) Math.round(Math.cos(angle) * 2);
			int dy = (int) Math.round(Math.sin(angle) * 2);
			for (int i = 1; i <= 8; i++) {
				int xx = tx + dx * i;
				int yy = ty + dy * i;
				if (xx > 8 || yy > 8 || xx < 1 || yy < 1) {
					break;
				}
				add(liste, e, xx, yy);
				if (checkOthers && e.getPiecePosition(xx, yy) != null) {
					break;
				}
			}
			angle += Math.PI / 2;
		}
		return liste;
	}

	public int getPoints() {
		return 3;
	}

	public char toSmallString() {
		if (couleur.isBlanc())
			return '♝';
		return '♗';
	}
}
