package net.kidanger.yourchess.yourchess.piece;

import java.util.LinkedList;
import java.util.List;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Echiquier;
import net.kidanger.yourchess.yourchess.Position;

public class Roi extends Piece {

	public Roi(Position position, Couleur couleur) {
		super(position, couleur);
	}

	protected void addIfValid(List<Position> l, int x, int y) {
		if (x > 1 && x <= 8 && y > 1 && y <= 8) {
			l.add(Position.get(x, y));
		}
	}

	private void add(List<Position> l, Echiquier e, int x, int y) {
		if (x < 1 || x > 8 || y < 1 || y > 8) {
			return;
		}
		if (e == null) {
			l.add(Position.get(x, y));
			return;
		}
		Piece p = e.getPiecePosition(x, y);
		if (p != null) {
			if (!isFriendly(p)) {
				l.add(Position.get(x, y));
			}
		} else {
			l.add(Position.get(x, y));
		}
	}

	public List<Position> getPossiblePositions(Echiquier e, boolean checkOthers) {
		List<Position> liste = new LinkedList<>();
		int tx = position.getX();
		int ty = position.getY();
		for (int dx = -1; dx <= 1; dx++) {
			for (int dy = -1; dy <= 1; dy++) {
				if (dx != 0 || dy != 0) {
					add(liste, e, tx + dx, ty + dy);
				}
			}
		}
		return liste;
	}

	public boolean estRoi() {
		return true;
	}

	public int getPoints() {
		return 0;
	}

	public char toSmallString() {
		if (couleur.isBlanc())
			return '♚';
		return '♔';
	}
}
