package net.kidanger.yourchess.yourchess.piece;

import java.util.LinkedList;
import java.util.List;

import net.kidanger.yourchess.yourchess.Couleur;
import net.kidanger.yourchess.yourchess.Echiquier;
import net.kidanger.yourchess.yourchess.Position;

public class Tour extends Piece {

	public Tour(Position position, Couleur couleur) {
		super(position, couleur);
	}

	private void add(List<Position> l, Echiquier e, int x, int y) {
		if (e == null) {
			l.add(Position.get(x, y));
			return;
		}
		Piece p = e.getPiecePosition(x, y);
		if (p != null) {
			if (!isFriendly(p)) {
				l.add(Position.get(x, y));
			}
		} else {
			l.add(Position.get(x, y));
		}
	}

	public List<Position> getPossiblePositions(Echiquier e, boolean checkOthers) {
		List<Position> liste = new LinkedList<>();
		int tx = position.getX();
		int ty = position.getY();

		for (int x = 1; x <= 8; x++) {
			if (tx + x < 1 || tx + x > 8) {
				break;
			}
			add(liste, e, tx + x, ty);
			if (checkOthers && e.getPiecePosition(tx + x, ty) != null) {
				break;
			}
		}

		for (int x = -1; x >= -8; x--) {
			if (tx + x < 1 || tx + x > 8) {
				break;
			}
			add(liste, e, tx + x, ty);
			if (checkOthers && e.getPiecePosition(tx + x, ty) != null) {
				break;
			}
		}

		for (int y = 1; y < 8; y++) {
			if (ty + y < 1 || ty + y > 8) {
				break;
			}
			add(liste, e, tx, ty + y);
			if (checkOthers && e.getPiecePosition(tx, ty + y) != null) {
				break;
			}
		}

		for (int y = -1; y >= -8; y--) {
			if (ty + y < 1 || ty + y > 8) {
				break;
			}
			add(liste, e, tx, ty + y);
			if (checkOthers && e.getPiecePosition(tx, ty + y) != null) {
				break;
			}
		}
		return liste;
	}

	public int getPoints() {
		return 3;
	}

	public char toSmallString() {
		if (couleur.isBlanc())
			return '♜';
		return '♖';
	}
}
