package fr.ensicaen.ecole.easygame.testClass;

import java.awt.Graphics;

import fr.ensicaen.ecole.easygame.state.Entity;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertNull;

/**
 * Class to test only accessors/mutators/constructors of Entity.java
 *
 * @author gaveriaux
 */
public final class EntityTest {

	private Entity _entity;

	@Before
	/**
	 * Initialisation of an Entity
	 */
	public void setup() {
		_entity = new MyEntity();
	}

	/**
	 * Check if there is no initial Player for an entity
	 */
	@Test
	public void testInitialPlayer() {
		assertNull(_entity.getPlayer());
	}

	/**
	 * New class MyEntity which is an Entity (Entity is in abstract)
	 */
	private class MyEntity extends Entity {

		private static final long serialVersionUID = 1L;

		@Override
		public void draw(Graphics g) {
		}
	}
}
