package fr.ensicaen.ecole.easygame.testClass;

import fr.ensicaen.ecole.easygame.state.RectangleShape;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

/**
 * Class to test only accessors/mutators/constructors of RectangleShape.java
 *
 * @author gaveriaux
 */
public final class RectangleShapeTest {

	private int _w;
	private int _h;
	private RectangleShape _rectangleShape;

	@Before
	/**
	 * Initialisation of a Shape
	 */
	public void setup() {
		_w = 10;
		_h = 15;
		_rectangleShape = new RectangleShape(_w, _h);
	}

	/**
	 * Check if there is no initial Player for an entity
	 */
	@Test
	public void testRectangleShapeW() {
		assertEquals(_rectangleShape.getW(), _w);
	}

	/**
	 * Check if there is no initial Player for an entity
	 */
	@Test
	public void testRectangleShapeH() {
		assertEquals(_rectangleShape.getH(), _h);
	}

	/**
	 * Check the contains method of RectangleShape
	 */
	@Test
	public void testRectangleShapeContains() {
		assertTrue(_rectangleShape.contains(0, 0));
		assertFalse(_rectangleShape.contains(_w, _h));

		assertFalse(_rectangleShape.contains(_w + 1, _h + 1));
		assertFalse(_rectangleShape.contains(-1, -1));
	}
}
