package fr.ensicaen.ecole.easygame.testClass;

import fr.ensicaen.ecole.easygame.state.RectangleShape;
import fr.ensicaen.ecole.easygame.state.Shape;
import fr.ensicaen.ecole.easygame.state.Zone;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertEquals;

/**
 * Class to test only accessors/mutators/constructors of Zone.java
 *
 * @author gaveriaux
 */
public final class ZoneTest {

	private int _x, _y;
	private Zone _zone;
	private Shape _shape;

	@Before
	/**
	 * Initialisation of a zone
	 */
	public void setup() {
		_x = 1;
		_y = 2;
		_shape = new RectangleShape(10, 10);
		_zone = new Zone(_x, _y, _shape);
	}

	/**
	 * Test of the h of the zone shape
	 */
	@Test
	public void zoneTestX() {
		assertEquals(_zone.getX(), _x);
	}

	/**
	 * Test of the h of the zone shape
	 */
	@Test
	public void zoneTestY() {
		assertEquals(_zone.getY(), _y);
	}

	/**
	 * Test of the shape of the zone shape
	 */
	@Test
	public void zoneTestShape() {
		assertEquals(_zone.getShape(), _shape);
	}
}
