package fr.ensicaen.ecole.easygame.testRelation;

import java.awt.Graphics;

import fr.ensicaen.ecole.easygame.state.Entity;
import fr.ensicaen.ecole.easygame.state.Player;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.*;

final class TestEntity extends Entity {

	private static final long serialVersionUID = 1L;

	@Override
	public void draw(Graphics g) {
	}
}

public final class EntityPlayerTest {

	private Player _player;
	private Player _player2;
	private Entity _entity;

	public class DummyPlayer extends Player {

		private static final long serialVersionUID = 1L;

		public DummyPlayer(int id) {
			super(id, "p" + id);
		}
	}

	@Before
	public void setup() {
		_player = new DummyPlayer(0);
		_player2 = new DummyPlayer(1);
		_entity = new TestEntity();
	}

	@Test
	public void playerAddEntity() {
		assertNull(_entity.getPlayer());
		_player.addEntity(_entity);
		assertSame(_entity.getPlayer(), _player);
	}

	@Test
	public void playerRemoveEntity() {
		_player.addEntity(_entity);
		_player.removeEntity(_entity);
		assertNull(_entity.getPlayer());
	}

	@Test
	public void entityChangePlayer() {
		_player.addEntity(_entity);
		assertSame(_entity.getPlayer(), _player);
		_player2.addEntity(_entity);
		assertSame(_entity.getPlayer(), _player2);
	}

	@Test
	public void playerChangedEntity() {
		_entity.setPlayer(_player);
		_entity.setPlayer(_player2);
		assertNotEquals(_player.getEntities(), _player2.getEntities());
	}
}
