package fr.ensicaen.ecole.easygame.testRelation;

import fr.ensicaen.ecole.easygame.state.RectangleShape;
import fr.ensicaen.ecole.easygame.state.Shape;
import fr.ensicaen.ecole.easygame.state.Zone;
import org.junit.Before;
import org.junit.Test;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertNotNull;

public final class ZoneShapeTest {

	private Shape _shape;
	private Zone _zone;
	private int _w, _h;

	@Before
	/**
	 * Initialization of a zone and a shape
	 */
	public void setup() {
		_w = 1;
		_h = 2;
		int x = 3;
		int y = 4;

		_shape = new RectangleShape(_w, _h);
		_zone = new Zone(x, y, _shape);
	}

	/**
	 * Test of the accessor of shape
	 */
	@Test
	public void zoneGetShape() {
		assertNotNull(_zone.getShape());
		assertEquals(_zone.getShape(), _shape);
	}

	/**
	 * Test of the w of the zone shape
	 */
	@Test
	public void zoneShapeTestW() {
		assertEquals(((RectangleShape) _shape).getW(), _w);
	}

	/**
	 * Test of the h of the zone shape
	 */
	@Test
	public void zoneShapeTestH() {
		assertEquals(((RectangleShape) _shape).getH(), _h);
	}
}
